package xyz.danielcortes.controllers.idioma;

import java.util.List;
import javax.swing.JComboBox;
import javax.swing.JOptionPane;
import xyz.danielcortes.models.Idioma;
import xyz.danielcortes.repository.IdiomaRepository;
import xyz.danielcortes.views.idioma.IdiomaUpdatePanel;

public class IdiomaUpdateController {

  private IdiomaUpdatePanel view;
  private IdiomaRepository idiomaRepository;

  public IdiomaUpdateController(IdiomaUpdatePanel view) {
    this.view = view;
    this.idiomaRepository = new IdiomaRepository();
    this.setupListeners();
  }

  private void setupListeners() {
    this.view.getIdiomaCombo().addActionListener(e -> {
      Idioma selected = (Idioma) this.view.getIdiomaCombo().getSelectedItem();
      if(selected != null)
        this.view.getNombreField().setText(selected.getNombre());
    });
    this.view.getNombreField().addActionListener(e -> this.update());
    this.view.getActualizarButton().addActionListener(e -> this.update());
  }

  private void update() {
    Idioma original = (Idioma) this.view.getIdiomaCombo().getSelectedItem();
    if (!validateOriginal(original)) return;

    String nombre = this.view.getNombreField().getText();
    if (!validateNombre(nombre)) return;

    assert original != null;
    original.setNombre(nombre);
    idiomaRepository.update(original);

    this.view.getNombreField().setText("");
    this.loadIdiomaCombo();
    this.view.getNombreField().requestFocus();
  }

  private boolean validateOriginal(Idioma original) {
    if (original == null) {
      JOptionPane.showMessageDialog(
          null,
          "No hay Idioma seleccionado",
          "Error",
          JOptionPane.ERROR_MESSAGE
      );
      return false;
    }
    return true;
  }

  private boolean validateNombre(String nombre) {
    if (nombre == null) {
      JOptionPane.showMessageDialog(
          this.view.getContentPane(),
          "El nombre es nulo",
          "Error",
          JOptionPane.ERROR_MESSAGE);
      return false;
    } else if (nombre.isEmpty()) {
      JOptionPane.showMessageDialog(
          this.view.getContentPane(),
          "El nombre esta vacío",
          "Error",
          JOptionPane.ERROR_MESSAGE);
      return false;
    }
    return true;
  }

  public void reload() {
    this.loadIdiomaCombo();
  }

  private void loadIdiomaCombo() {
    List<Idioma> idiomas = this.idiomaRepository.getAll();
    JComboBox<Idioma> combobox = this.view.getIdiomaCombo();
    combobox.removeAllItems();
    for (Idioma idioma : idiomas) {
      combobox.addItem(idioma);
    }
  }

  public IdiomaUpdatePanel getView() {
    return view;
  }

}
